import sql from "../sql";
import fetch from "flumm-fetch-cookies";

const data = {
  abschieben: [],
  kaffee: [],
  tee: [],
  milch: [],
  quotes_firecooler: [],
  quotes_kinski: [],
  quotes_stoll: [],
  quotes_boll: []
};

export default async bot => {

  Object.keys(data).forEach(cur => sql.any("select data from useless where trigger = $1 limit 1", [cur])
    .then(rows => data[cur] = JSON.parse(rows[0].data))
    .catch(console.error));

  return [{
    name: "abschieben",
    call: /^(\.|\/)abschieben/i,
    set: "uwe",
    f: e => {
      e.replyAction(`schiebt [b]${e.args[0] || e.user.nick}[/b] ${data.abschieben[~~(Math.random() * data.abschieben.length)]} ab.`);
    }
  }, {
    name: "butterkäse",
    call: /^(\.|\/)butterkäse/i,
    set: "uwe",
    f: e => {
      e.replyAction(`drischt mit einem großen Stück Butterkäse auf [b]${e.args[0] || e.user.nick}[/b] ein.`);
    }
  }, {
    name: "notschlachten",
    call: /^(\.|\/)notschlachten/i,
    set: "uwe",
    f: e => {
      e.replyAction(`notschlachtet [b]${e.args[0] || e.user.nick}[/b] und entsorgt die Leiche im Biomüll`);
    }
  }, {
    name: "lachs",
    call: /^(\.|\/)lachs/i,
    set: "uwe",
    f: e => {
      e.reply("öhöhöhöhöhöhö");
    }
  }, {
    name: "kaffee",
    call: /^(\.|\/)kaffee/i,
    set: "uwe",
    f: e => {
      e.replyAction(data.kaffee[~~(Math.random() * data.kaffee.length)].replace("{user}", `[b]${e.args[0] || e.user.nick}[/b]`));
    }
  }, {
    name: "milch",
    call: /^(\.|\/)milch/i,
    set: "uwe",
    f: e => {
      e.replyAction(data.milch[~~(Math.random() * data.milch.length)].replace("{user}", `[b]${e.args[0] || e.user.nick}[/b]`));
    }
  }, {
    name: "milchkaffee",
    call: /^(\.|\/)milchkaffee/i,
    set: "uwe",
    f: e => {
      e.replyAction(`serviert [b]${e.args[0] || e.user.nick}[/b] einen heißen halbschwarzen Kaffee mit 99% Kondensmilchanteil.`);
    }
  }, {
    name: "tee",
    call: /^(\.|\/)tee/i,
    set: "uwe",
    f: e => {
      e.replyAction(data.tee[~~(Math.random() * data.tee.length)].replace("{user}", `[b]${e.args[0] || e.user.nick}[/b]`));
    }
  }, {
    name: "uwe_quotes",
    call: /^(\.|\/)(boll|firecooler|kinski|stoll)$/i,
    set: "uwe",
    f: e => {
      e.reply(data[`quotes_${e.cmd}`][~~(Math.random() * data[`quotes_${e.cmd}`].length)]);
    }
  }, {
    name:"wusel",
    call: /^(\.|\/)wusel/i,
    set: "uwe",
    f: e => {
      e.replyAction(`wuselt [b]${e.args[0] || e.user.nick}[/b] über den Haufen.`);
    }
  }, {
    name: "mett",
    call: /^(\.|\/)mett/i,
    set: "uwe",
    f: e => {
      e.reply(`Jamba Mettscanner: [b]${e.args[0] || e.user.nick}[/b] ist zu ${~~(Math.random() * 100 + 1)}% Mett.`);
    }
  }, {
    name: "unfaehig",
    call: /^(\.|\/)unfähig/i,
    set: "uwe",
    f: e => {
      e.reply(`Jamba Fähigkeitenscanner: [b]${e.args[0] || e.user.nick}[/b] ist zu ${~~(Math.random() * 100 + 1)}% unfähig.`);
    }
  }, {
    name: "rotenburg",
    call: /^(\.|\/)rotenburg/i,
    set: "uwe",
    f: e => {
      e.replyAction(`verarbeitet [b]${e.args[0] || e.user.nick}[/b] zu Hackfleisch.`);
    }
  }, {
    name: "pee",
    call: /^(\.|\/)pee/i,
    set: "uwe",
    f: e => {
      e.replyAction(`pisst in [b]${e.args[0] || e.user.nick}[/b]s Gesicht.`);
    }
  }, {
    name: "ike",
    call: /^ike/i,
    set: "uwe",
    f: e => {
      e.reply("ike ike!");
    }
  }, {
    name: "rip",
    call: /^rip/i,
    set: "uwe",
    f: e => {
      e.reply("Rust in Pitabrot");
    }
  }, {
    name: "haram",
    call: /^(\.|\/)haram/i,
    set: "uwe",
    f: e => {
      e.reply(`[b]${e.args[0] || e.user.nick}[/b] ist ${(~~(Math.random() * 2) ? "haram" : "nicht haram")}.`);
    }
  }, {
    name: "sacklutscher",
    call: /^(\.|\/)lutschsack/i,
    set: "uwe",
    f: e => {
      e.reply(`[b]${e.user.nick}[/b] legt Rosen aus und lutscht den Sack von [b]${e.args[0] || e.user.nick}[/b]`);
    }
  }, {
    name: "kawaii",
    call: /kawaii/i,
    set: "uwe",
    f: e => {
      e.reply("⌒(o＾▽＾o)ノ so much kawaii");
    }
  }, {
    name: "hurrdurr",
    call: /^hurr$/i,
    set: "uwe",
    f: e => {
      e.reply("durr");
    }
  }, {
    name: "herpderp",
    call: /^herp$/i,
    set: "uwe",
    f: e => {
      e.reply("derp");
    }
  }, {
    name: "wasser",
    call: /^(\.|\/)wasser/i,
    set: "uwe",
    f: e => {
      e.replyAction(`kippt [b]${e.args[0] || e.user.nick}[/b] einen Eimer Wasser über den Kopf.`);
    }
  }, {
    name: "normie",
    call: /^(\.|\/)normie/i,
    set: "uwe",
    f: e => {
      e.reply(`Jamba Normiescanner: [b]${e.args[0] || e.user.nick}[/b] ist zu ${~~(Math.random() * 100 + 1)}% ein Normie.`);
    }
  }, {
    name: "hyper",
    call: /^(\.|\/)hyper$/i,
    set: "uwe",
    f: e => {
      e.reply("[b]GET HYPER![/b]");
    }
  }, {
    name: "bark",
    call: /^(\.|\/)bark$/i,
    set: "uwe",
    f: e => {
      e.reply("BARK BARK BARK");
    }
  }, {
    name: "meditieren",
    call: /^(\.|\/)meditieren/i,
    set: "uwe",
    f: e => {
      e.replyAction(`meditiert zusammen mit [b]${e.args[0] || e.user.nick}[/b] Metta.`);
    }
  }, {
    name: "duden",
    call: /^(\.|\/)duden/i,
    set: "uwe",
    f: e => {
      e.replyAction(`drischt mit einem großen Duden auf [b]${e.args[0] || e.user.nick}[/b] ein.`);
    }
  }, {
    name: "kscht",
    call: /^(\.|\/)kscht/i,
    set: "uwe",
    f: e => {
      e.replyAction(`jagt [b]${e.args[0] || e.user.nick}[/b] durch den Raum.`);
    }
  }, {
    name: "bullenpisse",
    call: /^(\.|\/)bullenpisse/i,
    set: "uwe",
    f: e => {
      e.replyAction(`zapft ein Fläschchen feinsten Bullenurin, verarbeitet diesen zu Red-Bull und serviert ihn [b]${e.args[0] || e.user.nick}[/b] in Form einer Pfanddose.`);
    }
  }, {
    name: "lungenkrebs",
    call: /^(\.|\/)lungenkrebs/i,
    set: "uwe",
    f: e => {
      e.replyAction(`dreht [b]${e.args[0] || e.user.nick}[/b] einen prall gefüllten Sargnagel mit feinstem Schwarzer Krauser.`);
    }
  }, {
    name: "blah",
    call: /^[A-ZÄÖÜẞ](?: [A-ZÄÖÜẞ]){1,5}$/,
    set: "uwe",
    clients: ["irc"],
    f: e => {
      let args = e.message.trim();
      if (args.toUpperCase() === args) e.reply(args.substring(2).split(" ").join("\n"));
    }
  }, {
    name: "rose",
    call: /^(\.|\/)rose/i,
    set: "uwe",
    f: e => {
      e.replyAction(`schenkt [b]${e.args[0] || e.user.nick}[/b] eine [color=red]~~{~[@}[/color]`);
    }
  }, {
    name: "wienerle",
    call: /^(\.|\/)wienerle/i,
    set: "uwe",
    f: e => {
      e.replyAction(`serviert [b]${e.args[0] || e.user.nick}[/b] ein kaltes Wienerle mit etwas Wurstwasser.`);
    }
  }, {
    name: "joke",
    call: /^(\.|\/)joke$/i,
    set: "uwe",
    f: e => { ///
      fetch("https://icanhazdadjoke.com/slack")
        .then(res => res.json())
        .then(res => {
          res = res.attachments[0].text;
          if(e.network !== "Telegram") {
            res
              .match(/.{1,450}/g)
              .map(e.reply);
          }
          else
            e.reply(res);
        }).catch(err => console.log(err));
    }
  }, { ///
    name: "version",
    call: /^\.version/i,
    set: "uwe",
    clients: ["irc"],
    f: e => {
      e.socket.once("data", res => {
        let verstring;
        try {
          verstring = res.match(/\u0001VERSION (.*?)\u0001/)[1];
        }
        catch(err) {
          verstring = false;
        };

        if(verstring)
          e.reply(`${e.user.nick}: ${verstring}`);
      });
      e.write(`privmsg ${e.args[0] || e.user.nick} :\u0001VERSION\u0001`);
    }
  }, {
    name: "mock",
    call: /^\.mock .*/i,
    set: "uwe",
    f: e => {
      e.reply([...e.args.join(" ")].map(l => (l === " ") ? " " : (Math.round(Math.random()) === 0) ? l.toUpperCase() : l.toLowerCase()).join``);
    }
  }, { ///
    name: "sync",
    call: /^\.sync.*/i,
    set: "uwe",
    f: e => {
      const sync = e.args[0] || "80s90s";
      fetch(`https://f0ck.space/sync.php?${sync}`)
        .then(res => res.json())
        .then(data => {
          if(data.err)
            e.reply("Channel nicht gefunden D:");
          else
            e.reply(`${data.name} @ https://sync.f0ck.space/r/${data.name} : ${data.user} Users, now playing: ${decodeURIComponent(data.title)}`);
        }).catch(err => e.reply("Channel nicht gefunden D:"));
    }
  }, {
    name: "blech",
    call: /^(\.|\/)blech/i,
    set: "uwe",
    f: e => {
      e.replyAction(`bereitet [b]${e.args[0] || e.user.nick}[/b] ein Blech Schore zu. Viel Vergnügen du Siffscheiße.`);
    }
  }, {
    name: "joghurt",
    call: /^(\.|\/)joghurt/i,
    set: "uwe",
    f: e => {
      e.replyAction(`spritzt [b]${e.args[0] || e.user.nick}[/b] 500ml Joghurt in den Arsch.`);
    }
  }, {
    name: "kelly",
    call: /^(\.|\/)kelly/i,
    set: "uwe",
    f: e => {
      e.replyAction(`dreht [b]${e.args[0] || e.user.nick}[/b]'s dreckige Kelly Family Musik leiser und spuckt [b]${e.args[0] || e.user.nick}[/b] ins Gesicht.`);
    }
  }, {
    name: "pflaumen",
    call: /^(\.|\/)pflaumen/i,
    set: "uwe",
    f: e => {
      e.replyAction(`sieht, wie [b]${e.args[0] || e.user.nick}[/b] Pflaumen aus dem Arsch fallen.`);
    }
  }, {
    name: "quark",
    call: /^(\.|\/)quark/i,
    set: "uwe",
    f: e => {
      e.replyAction(`schiebt [b]${e.args[0] || e.user.nick}[/b] 500g dickflüssigen Quark in den soften Arsch.`);
    }
  }, {
    name: "shrug",
    call: /^so what$/i,
    set: "uwe",
    f: e => {
      e.reply("¯\\_(ツ)_/¯");
    }
  }, {
    name: "wiedergeburt",
    call: /^(\.|\/)wiedergeburt$/i,
    set: "uwe",
    f: e => {
      e.reply("spielt Wiedergeburt aus, legt nxy vom Friedhof in die Monsterzone und beendet seinen Zug.");
    }
  }];
  
};
